// FullAccess
resource "azurerm_role_definition" "container_registry_fullaccess_definition" {
  name              = "container-registry-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.ContainerRegistry/register/action",
      "Microsoft.ContainerRegistry/locations/operationResults/read",
      "Microsoft.ContainerRegistry/checkNameAvailability/read",
      "Microsoft.ContainerRegistry/operations/read",
      "Microsoft.ContainerRegistry/registries/read",
      "Microsoft.ContainerRegistry/registries/write",
      "Microsoft.ContainerRegistry/registries/delete",
      "Microsoft.ContainerRegistry/registries/listCredentials/action",
      "Microsoft.ContainerRegistry/registries/regenerateCredential/action",
      "Microsoft.ContainerRegistry/registries/importImage/action",
      "Microsoft.ContainerRegistry/registries/getBuildSourceUploadUrl/action",
      "Microsoft.ContainerRegistry/registries/queueBuild/action",
      "Microsoft.ContainerRegistry/registries/listBuildSourceUploadUrl/action",
      "Microsoft.ContainerRegistry/registries/scheduleRun/action",
      "Microsoft.ContainerRegistry/registries/listUsages/read",
      "Microsoft.ContainerRegistry/registries/operationStatuses/read",
      "Microsoft.ContainerRegistry/registries/webhooks/read",
      "Microsoft.ContainerRegistry/registries/webhooks/write",
      "Microsoft.ContainerRegistry/registries/webhooks/delete",
      "Microsoft.ContainerRegistry/registries/webhooks/getCallbackConfig/action",
      "Microsoft.ContainerRegistry/registries/webhooks/ping/action",
      "Microsoft.ContainerRegistry/registries/webhooks/listEvents/action",
      "Microsoft.ContainerRegistry/registries/webhooks/operationStatuses/read",
      "Microsoft.ContainerRegistry/registries/replications/read",
      "Microsoft.ContainerRegistry/registries/replications/write",
      "Microsoft.ContainerRegistry/registries/replications/delete",
      "Microsoft.ContainerRegistry/registries/replications/operationStatuses/read",
      "Microsoft.ContainerRegistry/registries/eventGridFilters/read",
      "Microsoft.ContainerRegistry/registries/eventGridFilters/write",
      "Microsoft.ContainerRegistry/registries/eventGridFilters/delete",
      "Microsoft.ContainerRegistry/locations/deleteVirtualNetworkOrSubnets/action",
      "Microsoft.ContainerRegistry/registries/listPolicies/read",
      "Microsoft.ContainerRegistry/registries/updatePolicies/write",
      "Microsoft.ContainerRegistry/registries/pull/read",
      "Microsoft.ContainerRegistry/registries/push/write",
      "Microsoft.ContainerRegistry/registries/quarantineRead/read",
      "Microsoft.ContainerRegistry/registries/quarantineWrite/write",
      "Microsoft.ContainerRegistry/registries/sign/write",
      "Microsoft.ContainerRegistry/registries/builds/read",
      "Microsoft.ContainerRegistry/registries/builds/write",
      "Microsoft.ContainerRegistry/registries/builds/getLogLink/action",
      "Microsoft.ContainerRegistry/registries/builds/cancel/action",
      "Microsoft.ContainerRegistry/registries/buildTasks/read",
      "Microsoft.ContainerRegistry/registries/buildTasks/write",
      "Microsoft.ContainerRegistry/registries/buildTasks/delete",
      "Microsoft.ContainerRegistry/registries/buildTasks/listSourceRepositoryProperties/action",
      "Microsoft.ContainerRegistry/registries/buildTasks/steps/read",
      "Microsoft.ContainerRegistry/registries/buildTasks/steps/write",
      "Microsoft.ContainerRegistry/registries/buildTasks/steps/delete",
      "Microsoft.ContainerRegistry/registries/buildTasks/steps/listBuildArguments/action",
      "Microsoft.ContainerRegistry/registries/runs/read",
      "Microsoft.ContainerRegistry/registries/runs/write",
      "Microsoft.ContainerRegistry/registries/runs/listLogSasUrl/action",
      "Microsoft.ContainerRegistry/registries/runs/cancel/action",
      "Microsoft.ContainerRegistry/registries/tasks/read",
      "Microsoft.ContainerRegistry/registries/tasks/write",
      "Microsoft.ContainerRegistry/registries/tasks/delete",
      "Microsoft.ContainerRegistry/registries/tasks/listDetails/action",
      "Microsoft.ContainerRegistry/registries/artifacts/delete",
      "Microsoft.ContainerRegistry/registries/metadata/read",
      "Microsoft.ContainerRegistry/registries/metadata/write",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "container_registry_readonly_definition" {
  name              = "container-registry-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.ContainerRegistry/locations/operationResults/read",
      "Microsoft.ContainerRegistry/checkNameAvailability/read",
      "Microsoft.ContainerRegistry/operations/read",
      "Microsoft.ContainerRegistry/registries/read",
      "Microsoft.ContainerRegistry/registries/listUsages/read",
      "Microsoft.ContainerRegistry/registries/operationStatuses/read",
      "Microsoft.ContainerRegistry/registries/webhooks/read",
      "Microsoft.ContainerRegistry/registries/webhooks/operationStatuses/read",
      "Microsoft.ContainerRegistry/registries/replications/read",
      "Microsoft.ContainerRegistry/registries/replications/operationStatuses/read",
      "Microsoft.ContainerRegistry/registries/eventGridFilters/read",
      "Microsoft.ContainerRegistry/registries/listPolicies/read",
      "Microsoft.ContainerRegistry/registries/pull/read",
      "Microsoft.ContainerRegistry/registries/quarantineRead/read",
      "Microsoft.ContainerRegistry/registries/builds/read",
      "Microsoft.ContainerRegistry/registries/buildTasks/read",
      "Microsoft.ContainerRegistry/registries/buildTasks/steps/read",
      "Microsoft.ContainerRegistry/registries/runs/read",
      "Microsoft.ContainerRegistry/registries/tasks/read",
      "Microsoft.ContainerRegistry/registries/metadata/read",
    ]

    not_actions = [
      "Microsoft.ContainerRegistry/register/action",
      "Microsoft.ContainerRegistry/registries/write",
      "Microsoft.ContainerRegistry/registries/delete",
      "Microsoft.ContainerRegistry/registries/listCredentials/action",
      "Microsoft.ContainerRegistry/registries/regenerateCredential/action",
      "Microsoft.ContainerRegistry/registries/importImage/action",
      "Microsoft.ContainerRegistry/registries/getBuildSourceUploadUrl/action",
      "Microsoft.ContainerRegistry/registries/queueBuild/action",
      "Microsoft.ContainerRegistry/registries/listBuildSourceUploadUrl/action",
      "Microsoft.ContainerRegistry/registries/scheduleRun/action",
      "Microsoft.ContainerRegistry/registries/webhooks/write",
      "Microsoft.ContainerRegistry/registries/webhooks/delete",
      "Microsoft.ContainerRegistry/registries/webhooks/getCallbackConfig/action",
      "Microsoft.ContainerRegistry/registries/webhooks/ping/action",
      "Microsoft.ContainerRegistry/registries/webhooks/listEvents/action",
      "Microsoft.ContainerRegistry/registries/replications/write",
      "Microsoft.ContainerRegistry/registries/replications/delete",
      "Microsoft.ContainerRegistry/registries/eventGridFilters/write",
      "Microsoft.ContainerRegistry/registries/eventGridFilters/delete",
      "Microsoft.ContainerRegistry/locations/deleteVirtualNetworkOrSubnets/action",
      "Microsoft.ContainerRegistry/registries/updatePolicies/write",
      "Microsoft.ContainerRegistry/registries/push/write",
      "Microsoft.ContainerRegistry/registries/quarantineWrite/write",
      "Microsoft.ContainerRegistry/registries/sign/write",
      "Microsoft.ContainerRegistry/registries/builds/write",
      "Microsoft.ContainerRegistry/registries/builds/getLogLink/action",
      "Microsoft.ContainerRegistry/registries/builds/cancel/action",
      "Microsoft.ContainerRegistry/registries/buildTasks/write",
      "Microsoft.ContainerRegistry/registries/buildTasks/delete",
      "Microsoft.ContainerRegistry/registries/buildTasks/listSourceRepositoryProperties/action",
      "Microsoft.ContainerRegistry/registries/buildTasks/steps/write",
      "Microsoft.ContainerRegistry/registries/buildTasks/steps/delete",
      "Microsoft.ContainerRegistry/registries/buildTasks/steps/listBuildArguments/action",
      "Microsoft.ContainerRegistry/registries/runs/write",
      "Microsoft.ContainerRegistry/registries/runs/listLogSasUrl/action",
      "Microsoft.ContainerRegistry/registries/runs/cancel/action",
      "Microsoft.ContainerRegistry/registries/tasks/write",
      "Microsoft.ContainerRegistry/registries/tasks/delete",
      "Microsoft.ContainerRegistry/registries/tasks/listDetails/action",
      "Microsoft.ContainerRegistry/registries/artifacts/delete",
      "Microsoft.ContainerRegistry/registries/metadata/write",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "container_registry_noaccess_definition" {
  name              = "container-registry-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.ContainerRegistry/register/action",
      "Microsoft.ContainerRegistry/locations/operationResults/read",
      "Microsoft.ContainerRegistry/checkNameAvailability/read",
      "Microsoft.ContainerRegistry/operations/read",
      "Microsoft.ContainerRegistry/registries/read",
      "Microsoft.ContainerRegistry/registries/write",
      "Microsoft.ContainerRegistry/registries/delete",
      "Microsoft.ContainerRegistry/registries/listCredentials/action",
      "Microsoft.ContainerRegistry/registries/regenerateCredential/action",
      "Microsoft.ContainerRegistry/registries/importImage/action",
      "Microsoft.ContainerRegistry/registries/getBuildSourceUploadUrl/action",
      "Microsoft.ContainerRegistry/registries/queueBuild/action",
      "Microsoft.ContainerRegistry/registries/listBuildSourceUploadUrl/action",
      "Microsoft.ContainerRegistry/registries/scheduleRun/action",
      "Microsoft.ContainerRegistry/registries/listUsages/read",
      "Microsoft.ContainerRegistry/registries/operationStatuses/read",
      "Microsoft.ContainerRegistry/registries/webhooks/read",
      "Microsoft.ContainerRegistry/registries/webhooks/write",
      "Microsoft.ContainerRegistry/registries/webhooks/delete",
      "Microsoft.ContainerRegistry/registries/webhooks/getCallbackConfig/action",
      "Microsoft.ContainerRegistry/registries/webhooks/ping/action",
      "Microsoft.ContainerRegistry/registries/webhooks/listEvents/action",
      "Microsoft.ContainerRegistry/registries/webhooks/operationStatuses/read",
      "Microsoft.ContainerRegistry/registries/replications/read",
      "Microsoft.ContainerRegistry/registries/replications/write",
      "Microsoft.ContainerRegistry/registries/replications/delete",
      "Microsoft.ContainerRegistry/registries/replications/operationStatuses/read",
      "Microsoft.ContainerRegistry/registries/eventGridFilters/read",
      "Microsoft.ContainerRegistry/registries/eventGridFilters/write",
      "Microsoft.ContainerRegistry/registries/eventGridFilters/delete",
      "Microsoft.ContainerRegistry/locations/deleteVirtualNetworkOrSubnets/action",
      "Microsoft.ContainerRegistry/registries/listPolicies/read",
      "Microsoft.ContainerRegistry/registries/updatePolicies/write",
      "Microsoft.ContainerRegistry/registries/pull/read",
      "Microsoft.ContainerRegistry/registries/push/write",
      "Microsoft.ContainerRegistry/registries/quarantineRead/read",
      "Microsoft.ContainerRegistry/registries/quarantineWrite/write",
      "Microsoft.ContainerRegistry/registries/sign/write",
      "Microsoft.ContainerRegistry/registries/builds/read",
      "Microsoft.ContainerRegistry/registries/builds/write",
      "Microsoft.ContainerRegistry/registries/builds/getLogLink/action",
      "Microsoft.ContainerRegistry/registries/builds/cancel/action",
      "Microsoft.ContainerRegistry/registries/buildTasks/read",
      "Microsoft.ContainerRegistry/registries/buildTasks/write",
      "Microsoft.ContainerRegistry/registries/buildTasks/delete",
      "Microsoft.ContainerRegistry/registries/buildTasks/listSourceRepositoryProperties/action",
      "Microsoft.ContainerRegistry/registries/buildTasks/steps/read",
      "Microsoft.ContainerRegistry/registries/buildTasks/steps/write",
      "Microsoft.ContainerRegistry/registries/buildTasks/steps/delete",
      "Microsoft.ContainerRegistry/registries/buildTasks/steps/listBuildArguments/action",
      "Microsoft.ContainerRegistry/registries/runs/read",
      "Microsoft.ContainerRegistry/registries/runs/write",
      "Microsoft.ContainerRegistry/registries/runs/listLogSasUrl/action",
      "Microsoft.ContainerRegistry/registries/runs/cancel/action",
      "Microsoft.ContainerRegistry/registries/tasks/read",
      "Microsoft.ContainerRegistry/registries/tasks/write",
      "Microsoft.ContainerRegistry/registries/tasks/delete",
      "Microsoft.ContainerRegistry/registries/tasks/listDetails/action",
      "Microsoft.ContainerRegistry/registries/artifacts/delete",
      "Microsoft.ContainerRegistry/registries/metadata/read",
      "Microsoft.ContainerRegistry/registries/metadata/write",
    ]
  }
}
